
INCLUDE Irvine32.inc
INCLUDE macros.inc


.data
num1      DWORD 0
num2      DWORD 0
plusMinus1 BYTE '+'
plusMinus2 BYTE '+'
operator  BYTE ?
stringInput BYTE 35 DUP  (0) 
error1 BYTE "	BAD INPUT, run prog again to get correct results",0
error2 BYTE "	OVERFLOW",0

.code
main PROC

mov edx, OFFSET stringInput
mov ecx, SIZEOF stringInput
call ReadString
mov ecx,eax
mov esi,0
call retrieveChar ;Retrieves first character , whether it be a sign or a number
call checkElement ;Checks for the sign, then retrieves the first number
call retrieveChar ;Retrieves second character. whether it be sign or number
call checkElement2 ;Checks for the sign, then retrieves second number
call checkOperation ;Performs the operation (Note at the end of check Element, the operator was found and stored into operator

main ENDP


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
retrieveChar PROC
mov al, stringInput[esi]
inc esi
ret
retrieveChar ENDP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
checkElement PROC
cmp al, '+'
je sign1
cmp al,'-'
je sign1
call IsDigit
jz n1


bad:
call BadInput
exit

sign1:
mov plusMinus1,al
call retrieveChar
cmp al,30h
;jb try_again
cmp al,39h
jbe n1
;jmp try_again

n1:
sub al,30h
mov ebx,0
mov bl,al
mov eax,num1
imul eax,10
add eax,ebx
mov num1, eax

call retrieveChar
call IsDigit
jz n1
mov operator,al
cmp plusMinus1,'-'
jz negative
jmp end1
negative:
neg num1

end1:
ret
checkElement ENDP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
checkElement2 PROC
cmp al, '+'
je sign2
cmp al,'-'
je sign2
jmp n2

sign2:
mov plusMinus2,al
call retrieveChar
cmp al,30h
;jb try_again
cmp al,39h
jbe n2
;jmp try_again

n2:
sub al,30h
mov ebx,0
mov bl,al
mov eax,num2
imul eax,10
add eax,ebx
mov num2, eax

call retrieveChar
call IsDigit
jz n2
cmp plusMinus2,'-'
jz negative
jmp end2
negative:
neg num2

end2:
ret
checkElement2 ENDP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
checkOperation PROC
 
 mov al,operator
       cmp al,'+'
       jz addition
       
       cmp al,'-'
       jz subtraction
       
       cmp al,'*'
       jz multiplication
       
       cmp al,'/'
       jz division
       
       cmp al,'%'
       jz remainder
       
              addition:
       mov eax,num1
       add eax,num2
       call WriteInt
       jmp finishline
       
       subtraction:
       mov eax,num1
       sub eax,num2
       call WriteInt
       jmp finishline
       
       multiplication:
       mov eax,num1
       mov ebx,num2
       mul ebx
       call WriteInt
       jmp finishline
       
       division:
       mov eax,num1
       cdq
       mov ebx,num2
       idiv ebx
       call WriteInt
       jmp finishline
       
       remainder:
       mov eax,num1
       cdq
       mov ebx,num2
       idiv ebx
       mov eax,edx
       call WriteInt      
       finishline:
       
checkOperation ENDP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

BadInput PROC
mov edx, OFFSET error1
call WriteString
call Crlf
exit
BadInput ENDP


END main
